package cz.cvut.fel.alg.tut4pr5;

import java.util.ArrayList;
import java.util.List;

/**
 * A simple n-ary tree representation.
 *
 * @author Petr Ryšavý
 */
public class Tree
{
    protected final char key;
    protected final List<Tree> children;

    public Tree(char key)
    {
        this.key = key;
        this.children = new ArrayList<>();
    }

    /**
     * Prints the tree to System.out.
     */
    public void print()
    {
        System.out.println(this);
        for (Tree t : children)
            t.print();
    }

    @Override
    public String toString()
    {
        StringBuilder sb = new StringBuilder();
        sb.append("Tree [").append(key).append("] : ");
        for (Tree t : children)
            sb.append(t.key).append(',');
        sb.deleteCharAt(sb.length() - 1);
        return sb.toString();
    }
}
